#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire10six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 10"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire10six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six104xi            # 10   - 90 



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six104xi = {
                1:'-11x47y-49z',
                2:'-12x13y-7z',
                3:'-13x12y-7z',
                4:'-13x12y-8z',
                5:'-13x46y-50z',
                6:'-14x10y-8z',
                7:'-14x11y-8z',
                8:'-15x45y-50z',
                9:'-15x8y-8z',
                10:'-15x9y-8z',
                11:'-16x4y-9z',
                12:'-16x5y-9z',
                13:'-16x6y-9z',
                14:'-16x7y-9z',
                15:'-17x44y-51z',
                16:'-19x42y-51z',
                17:'-1x0y-59z',
                18:'-1x11y-27z',
                19:'-1x9y-2z',
                20:'-25x0y-15z',
                21:'-25x1y-15z',
                22:'-25x2y-15z',
                23:'-25x3y-14z',
                24:'-25x46y-59z',
                25:'-25x5y-14z',
                26:'-27x45y-60z',
                27:'-29x43y-60z',
                28:'-2x11y-27z',
                29:'-2x9y-2z',
                30:'-2x9y-3z',
                31:'-31x41y-61z',
                32:'-32x38y-61z',
                33:'-34x36y-62z',
                34:'-35x34y-62z',
                35:'-35x48y0z',
                36:'-36x32y-63z',
                37:'-37x46y0z',
                38:'-38x29y-63z',
                39:'-39x24y-64z',
                40:'-39x27y-64z',
                41:'-3x10y-27z',
                42:'-3x8y-3z',
                43:'-3x9y-28z',
                44:'-40x22y-65z',
                45:'-40x44y0z',
                46:'-42x42y-1z',
                47:'-44x40y-1z',
                48:'-46x22y-73z',
                49:'-46x37y-2z',
                50:'-48x35y-3z',
                51:'-4x8y-3z',
                52:'-4x9y-28z',
                53:'-50x32y-3z',
                54:'-51x29y-4z',
                55:'-53x27y-4z',
                56:'-54x24y-5z',
                57:'-55x21y-6z',
                58:'-56x18y-6z',
                59:'-57x15y-7z',
                60:'-5x0y-49z',
                61:'-5x7y-3z',
                62:'-67x14y-9z',
                63:'-68x0y-12z',
                64:'-68x10y-9z',
                65:'-68x3y-11z',
                66:'-68x7y-10z',
                67:'-6x0y-49z',
                68:'-6x11y-37z',
                69:'-6x49y-48z',
                70:'-7x0y-49z',
                71:'-7x10y-37z',
                72:'-7x1y-49z',
                73:'-7x4y-38z',
                74:'-7x7y-38z',
                75:'-7x8y-38z',
                76:'-7x9y-38z',
                77:'-8x1y-49z',
                78:'-8x2y-49z',
                79:'-8x48y-49z',
                80:'-8x4y-38z',
                81:'-8x5y-38z',
                82:'-8x6y-38z',
                83:'-9x3y-48z',
                84:'-9x3y-49z',
                85:'-9x4y-48z',
                86:'0x0y-59z',
                87:'0x12y-27z'}
       


#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire10six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire10six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE10SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE10SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE10SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE10SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE10SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six104xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE10SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE10SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE10SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six10x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six10x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE10SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE10SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE10SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire10six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
